/*内部类可以引用外部类的成员变量和成员方法
  限制：1、非静态内部类可以调用外部类的任意成员和方法
  		2、获得内部类对象必须先实例化外部类对象
  					TestThree.Demo d1 = new TestThree().new Demo();
  		3、如果内部类中有静态的成员变量或者静态成员方法，那么他只能引用外部类的静态成员和静态方法
  		4、可直接通过类名调用静态内部类  TestThree.Demo2.test2();
*/
public class Test3{
	public int x;
	private int y;
	private static int z;
	public void show1(){
		System.out.println("method show"+x);
	}
	public static void show2(){
		System.out.println("static method show"+z);
	}

	public static void main(String[] args){
		TestThree.Demo d1 = new TestThree().new Demo();//非静态内部类必须先实例化外部类对象在实例化内部类对象
		d1.test1();
		Demo2.test2();//直接通过类名调用静态方法
	}
//非静态内部类,可以调用外部类的所有访问级别的成员，包括静态和非静态
	class Demo{
		void test1(){
			x=1;//实例成员
			z=1;//静态成员
			show1();//实例方法
			show2();//静态方法
		}
	}	
//静态内部类
	static class Demo2{
		//int x;
	public static void test2(){//只能调用外部类的静态成员和静态方法
		z=2;
		TestThree t= new TestThree();
		t.x=2;
		t.show1();//只能通过外部类的实力访问非静态成员变量和方法
		show2();
	}
	}	
}